#Область ОписаниеПеременных

Перем ИмяМетода; // Имя перехватываемого метода
Перем Тип;       // Тип перехватчика
Перем Тело;      // Тело перехватчика

#КонецОбласти

// Конструктор
//
// Параметры:
//   ИмяПерехватываемогоМетода - Строка - Имя метода для которого предназначен перехватчик
//
Процедура ПриСозданииОбъекта(ИмяПерехватываемогоМетода)
	
	ИмяМетода = ИмяПерехватываемогоМетода;

КонецПроцедуры

#Область ПрограммныйИнтерфейс

// Устанавливает тело перехватчика
//
// Параметры:
//   ТелоПерехватчика - Строка - Устанавливаемое тело перехватчика
//
//  Возвращаемое значение:
//   Перехватчик - Ссылка на текущий инстанс Перехватчик
//
Функция Тело(ТелоПерехватчика) Экспорт
	
	Тело = ТелоПерехватчика;

	Возврат ЭтотОбъект;

КонецФункции

// Устанавливает тип перехватчика
//
// Параметры:
//   ТипПерехватчика - ТипыПерехватчиковМетода - Устанавливаемое тип перехватчика
//
//  Возвращаемое значение:
//   Перехватчик - Ссылка на текущий инстанс Перехватчик
//
Функция ТипПерехватчика(ТипПерехватчика) Экспорт
	
	Тип = ТипПерехватчика;

	Возврат ЭтотОбъект;

КонецФункции

#КонецОбласти

#Область СлужебныйПрограммныйИнтерфейс

// Описание перехватчика
//
//  Возвращаемое значение:
//   Структура - описание перехватчика:
//     * ИмяМетода - Строка - Перехватываемый метод
//     * ТипПерехватчика - ТипыПерехватчиковМетода - Тип перехватчика
//     * ТелоПерехватчика - Строка - Исполняемый код перехватчика
//
Функция Описание() Экспорт
	
	Возврат Новый Структура(
		"ИмяМетода, ТипПерехватчика, ТелоПерехватчика",
		ИмяМетода,
		Тип,
		Тело 
	);

КонецФункции

#КонецОбласти
