﻿// Реализация шагов BDD-фич/сценариев c помощью фреймворка https://github.com/artbear/1bdd

Перем БДД; //контекст фреймворка 1bdd

// Метод выдает список шагов, реализованных в данном файле-шагов
Функция ПолучитьСписокШагов(КонтекстФреймворкаBDD) Экспорт
	БДД = КонтекстФреймворкаBDD;
	
	ВсеШаги = Новый Массив;
	ВсеШаги.Добавить("ЯПолучаюВыводСтатусаЧерезКоманду");
	ВсеШаги.Добавить("ЯМодифицируюВременныйФайл");
	ВсеШаги.Добавить("ЯИзменяюГитомИмяВременногоФайлаНа");
	ВсеШаги.Добавить("ЯУдаляюВременныйФайл");
	ВсеШаги.Добавить("ЯПолучаюМассивФайловКДобавлению");
	ВсеШаги.Добавить("ЯПолучаюМассивФайловВнеИндекса");
	ВсеШаги.Добавить("ЯПолучаюМассивФайловКУдалению");
	ВсеШаги.Добавить("ЯПолучаюМассивНеослеживаемыхФайлов");
	ВсеШаги.Добавить("МассивФайловСодержит");
	
	Возврат ВсеШаги;
КонецФункции

// Реализация шагов

// Процедура выполняется перед запуском каждого сценария
Процедура ПередЗапускомСценария(Знач Узел) Экспорт
	
КонецПроцедуры

// Процедура выполняется после завершения каждого сценария
Процедура ПослеЗапускаСценария(Знач Узел) Экспорт

КонецПроцедуры

//Я получаю вывод Статуса через команду
Процедура ЯПолучаюВыводСтатусаЧерезКоманду() Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ГитРепозиторий.ДанныеСтатуса().Получить();
КонецПроцедуры

//Я получаю Массив файлов к добавлению
Процедура ЯПолучаюМассивФайловКДобавлению() Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ТаблицаСтатусовМассивФайлов = ГитРепозиторий.ДанныеСтатуса().КДобавлению();
	БДД.СохранитьВКонтекст("ТаблицаСтатусовМассивФайлов", ТаблицаСтатусовМассивФайлов);
КонецПроцедуры

//Я получаю Массив файлов вне индекса
Процедура ЯПолучаюМассивФайловВнеИндекса() Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ТаблицаСтатусовМассивФайлов = ГитРепозиторий.ДанныеСтатуса().ВнеИндекса();
	БДД.СохранитьВКонтекст("ТаблицаСтатусовМассивФайлов", ТаблицаСтатусовМассивФайлов);
КонецПроцедуры

//Я получаю Массив файлов к удалению
Процедура ЯПолучаюМассивФайловКУдалению() Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ТаблицаСтатусовМассивФайлов = ГитРепозиторий.ДанныеСтатуса().КУдалению();
	БДД.СохранитьВКонтекст("ТаблицаСтатусовМассивФайлов", ТаблицаСтатусовМассивФайлов);
КонецПроцедуры

//Я получаю Массив неослеживаемых файлов
Процедура ЯПолучаюМассивНеослеживаемыхФайлов() Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ТаблицаСтатусовМассивФайлов = ГитРепозиторий.ДанныеСтатуса().НеОтслеживаются();
	БДД.СохранитьВКонтекст("ТаблицаСтатусовМассивФайлов", ТаблицаСтатусовМассивФайлов);
КонецПроцедуры

//Массив файлов содержит
Процедура МассивФайловСодержит(ИмяФайла) Экспорт
	ТаблицаСтатусовМассивФайлов = БДД.ПолучитьИзКонтекста("ТаблицаСтатусовМассивФайлов");
	Ожидаем.Что(ТаблицаСтатусовМассивФайлов).Содержит(ИмяФайла);
КонецПроцедуры

//Я модифицирую временный файл
Процедура ЯМодифицируюВременныйФайл() Экспорт
	ВременныйФайл = БДД.ПолучитьИзКонтекста("ВременныйФайл");
	ЗаписьФайла = Новый ЗаписьТекста(ВременныйФайл);
	ЗаписьФайла.ЗаписатьСтроку("Модификация");
	ЗаписьФайла.Закрыть();
КонецПроцедуры

//Я удаляю временный файл
Процедура ЯУдаляюВременныйФайл() Экспорт
	ВременныйФайл = БДД.ПолучитьИзКонтекста("ВременныйФайл");
	УдалитьФайлы(ВременныйФайл);
КонецПроцедуры

//Я изменяю имя временного файла на "tempХ.tmp"
Процедура ЯИзменяюГитомИмяВременногоФайлаНа(ИмяФайла) Экспорт
	ГитРепозиторий = БДД.ПолучитьИзКонтекста("ГитРепозиторий");
	ВременныйФайл = БДД.ПолучитьИзКонтекста("ВременныйФайл");
	Файл = Новый Файл(ВременныйФайл);
	ПараметрыКоманды = Новый Массив();
	ПараметрыКоманды.Добавить("mv");
	ПараметрыКоманды.Добавить("""" + Файл.Имя + """");
	ПараметрыКоманды.Добавить("""" + ИмяФайла + """");
	ГитРепозиторий.ВыполнитьКоманду(ПараметрыКоманды);
	БДД.СохранитьВКонтекст("ВременныйФайл", ИмяФайла);
КонецПроцедуры
